SoPickAction(3)

NAME
SoPickAction - The SoPickAction class is the base class for picking actions.

SYNOPSIS

#include <Inventor/actions/SoPickAction.h>

Inherits SoAction.

Inherited by SoRayPickAction.

  Public Member Functions
virtual SoType getTypeId (void) const
void setViewportRegion (const SbViewportRegion &newregion)
const SbViewportRegion & getViewportRegion (void) const
void enableCulling (const SbBool flag)
SbBool isCullingEnabled (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void addMethod (const SoType type, SoActionMethod method)
static void enableElement (const SoType type, const int stackindex)
static void initClass (void)

  Protected Member Functions
virtual const SoEnabledElementsList & getEnabledElements (void) const
SoPickAction (const SbViewportRegion &viewportregion)
virtual ~SoPickAction (void)
virtual void beginTraversal (SoNode *node)

  Static Protected Member Functions
static SoEnabledElementsList * getClassEnabledElements (void)
static SoActionMethodList * getClassActionMethods (void)

  Protected Attributes
SbViewportRegion vpRegion

  Additional Inherited Members

Detailed Description

The SoPickAction class is the base class for picking actions. The basis for all interaction features that Coin provides for the application programmer is the pick actions. Draggers, manipulators, SoSelection nodes, etc all make use of the functionality provided by the pick actions for selecting and manipulating scene geometry in various ways.

This class is not supposed to be used directly by the application programmer, as it is more a place-holder for the common interface of picking operations. It does not contain any actual code for doing scene graph picks.

Coin provides a fully functional picking action for the application programmer to use through the SoRayPickAction class (which inherits the SoPickAction class).

See also
    SoSelection

Constructor & Destructor Documentation

  SoPickAction::SoPickAction (const SbViewportRegion & viewportregion) [protected]
Constructor.

  SoPickAction::~SoPickAction (void) [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoPickAction::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and 'downward' casting.

Implements SoAction.

Reimplemented in SoRayPickAction.

  SoType SoPickAction::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  void SoPickAction::addMethod (const SoType type, SoActionMethod method) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoPickAction::enableElement (const SoType type, const int stackindex) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  const SoEnabledElementsList & SoPickAction::getEnabledElements (void) const [protected], [virtual]
Returns list of enabled elements.

Reimplemented from SoAction.

Reimplemented in SoRayPickAction.

  SoEnabledElementsList * SoPickAction::getClassEnabledElements (void) [static], [protected]
Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  SoActionMethodList * SoPickAction::getClassActionMethods (void) [static], [protected]
Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  void SoPickAction::initClass (void) [static]
Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

  void SoPickAction::setViewportRegion (const SbViewportRegion & newregion)
Set a new viewport region to replace the one passed in with the constructor.

  const SbViewportRegion & SoPickAction::getViewportRegion (void) const
Returns the viewport region used by the action.

  void SoPickAction::enableCulling (const SbBool flag)
Don't calculate bounding boxes and try to do culling when picking.

This can provide a speed-up in cases where the default setting of on would be inefficient.

  SbBool SoPickAction::isCullingEnabled (void) const
Returns the current state of the culling flag.

  void SoPickAction::beginTraversal (SoNode * node) [protected], [virtual]
This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoAction.

Reimplemented in SoRayPickAction.

Member Data Documentation

  SbViewportRegion SoPickAction::vpRegion [protected]
The viewport region used by pick actions.

Author

Generated automatically by Doxygen for Coin from the source code.